<?php
    use DVDoug\BoxPacker\Packer;
    use DVDoug\BoxPacker\FlavorCloud\FlavorCloudBox;  // use custom `Box` implementation
    use DVDoug\BoxPacker\FlavorCloud\FlavorCloudItem; // use custom `Item` implementation
    $packer = new Packer();

    /*
     * Add choices of box type
     */

    // Get the current WooCommerce settings
    $units = fcsfw_get_woocommerce_weight_and_dimension_units();
    $weight_unit_api = $units['weight_unit'];
    $dimension_unit_api = $units['dimension_unit'];
    $weight_unit = get_option( 'woocommerce_weight_unit');
    if ($weight_unit == 'lbs') {
        $weight_unit = 'lb';
    }
    $dimension_unit = get_option( 'woocommerce_dimension_unit');
/*
    echo 'Weight Unit Site: '.$weight_unit;
    echo '<br>';
    echo 'Dimension Unit Site: '.$dimension_unit;
    echo '<br>';
    echo 'Weight Unit API: '.$weight_unit_api;
    echo '<br>';
    echo 'Dimension Unit API: '.$dimension_unit_api;
    echo '<br>';
    echo '<br>';
    //$converted_weight = fcsfw_convertUnits(10,$weight_unit,strtolower($weight_unit_api)); 
    //echo '$converted_weight: '.$converted_weight;

    echo 'Boxes: '.fcsfw_print_array($boxes);
    echo '<br>';
*/
    foreach ( $boxes as $box ) {
        $converted_weight_box = fcsfw_convertUnits($box['Weight'],$weight_unit,"g");
        if($converted_weight_box == 0) {
            $converted_weight_box = 0.01;
        }
        $converted_max_weight_box = fcsfw_convertUnits($box['MaxWeight'],$weight_unit,"g");
        $converted_length_box = fcsfw_convertUnits($box['Length'],$dimension_unit,"mm");
        $converted_width_box = fcsfw_convertUnits($box['Width'],$dimension_unit,"mm");
        $converted_height_box = fcsfw_convertUnits($box['Height'],$dimension_unit,"mm");

        $packer->addBox(new FlavorCloudBox($box['Name'],
            $converted_width_box, 
            $converted_length_box, 
            $converted_height_box, 
            $converted_weight_box, 
            $converted_width_box, 
            $converted_length_box, 
            $converted_height_box, 
            $converted_max_weight_box
        ));
/*
        echo '<br>';
        echo 'Box Name: '.$box['Name'];
        echo '<br>';
        echo 'Box Width: '.$converted_width_box;
        echo '<br>';
        echo 'Box Length: '.$converted_length_box;
        echo '<br>';
        echo 'Box Height: '.$converted_height_box;
        echo '<br>';
        echo 'Box Weight: '.$converted_weight_box;
        echo '<br>';
        echo 'Box MAX Weight: '.$converted_max_weight_box;
        echo '<br>';
        echo '<br>';
        */
    }



    /*
     * Add items to be packed - e.g. from shopping cart stored in user session.
     */
    foreach($items as $item) {
        $converted_weight_item = fcsfw_convertUnits($item['Weight'],$weight_unit,"g");
        if($converted_weight_item == 0) {
            $converted_weight_item = 0.01;
        }
        $converted_length_item = fcsfw_convertUnits($item['Length'],$dimension_unit,"mm");
        $converted_width_item = fcsfw_convertUnits($item['Width'],$dimension_unit,"mm");
        $converted_height_item = fcsfw_convertUnits($item['Height'],$dimension_unit,"mm");

        //$this->debug( fcsfw_print_array($item));
        //$this->debug( fcsfw_print_array($item['Weight']));
        //$this->debug( fcsfw_print_array($converter->convert($item['Weight'])->from("lb")->to("g")));
        $packer->addItem(new FlavorCloudItem(
        $item['Name'], 
        $converted_width_item, 
        $converted_length_item, 
        $converted_height_item, 
        $converted_weight_item, true), $item['Quantity']); // item, quantity
/*
        echo '<br>';
        echo '<br>';
        echo 'Item Name: '.$item['Name'];
        echo '<br>';
        echo 'Item Width: '.$converted_width_item;
        echo '<br>';
        echo 'Item Length: '.$converted_length_item;
        echo '<br>';
        echo 'Item Height: '.$converted_height_item;
        echo '<br>';
        echo 'Item Weght: '.$converted_weight_item;
        echo '<br>';
        echo 'Item Qty: '.$item['Quantity'];
        echo '<br>';
        */
    }


    // If no boxes are found to fit the item
    try {
        $packedBoxes = $packer->pack();
    } catch (DVDoug\BoxPacker\NoBoxesAvailableException $e) {
        
        // Display error MSG
        //fcsfw_print_array($e->getMessage());
        fcsfw_logger('NO PACKING BOXES THAT FIT THIS ITEM/S HAVE BEEN FOUND.');

        // fallback action here, for example:
        // $packedBoxes = useDefaultBox();
    }
    /*
    fcsfw_print_array($packedBoxes);
    foreach ($packedBoxes as $packedBox) {
        $boxType = $packedBox->getBox();
        fcsfw_print_array($boxType);
    }
    */
    //echo "These items fitted into " . count($packedBoxes) . " box(es)" . PHP_EOL;

/*
    foreach ($packedBoxes as $packedBox) {
        $boxType = $packedBox->getBox(); // Box object

        var_dump($boxType);

        //echo "This box is a {$boxType->getReference()}, it is {$converter->convert($boxType->getOuterWidth())->from("cm")->to("in")}in wide, {$converter->convert($boxType->getOuterLength())->from("cm")->to("in")}in long and {$converter->convert($boxType->getOuterDepth())->from("cm")->to("in")}in high" . PHP_EOL;
        //echo "The combined weight of this box and the items inside it is {$packedBox->getWeight()}g" . PHP_EOL;

         //echo "The items in this box are:" . PHP_EOL;
        // $packedItems = $packedBox->getItems();
        // foreach ($packedItems as $packedItem) { // $packedItem->getItem() is your own item object, in this case TestItem
        //    echo $packedItem->getItem()->getDescription() . PHP_EOL;
        // }
        // break;
        //$this->debug( fcsfw_print_array($boxType->getReference()));
        //$key = array_search('Medium', $boxes);
        //$key = array_search('Medium', $boxes);
        //$this->debug( fcsfw_print_array(array_search(0, $boxes)));
        //$this->debug( fcsfw_print_array($boxes));
        $converted_weight_box = fcsfw_convertUnits($boxType->getEmptyWeight(),"g",$weight_unit);
        if($converted_weight_box == 0) {
            $converted_weight_box = 0.01;
        }

        //fcsfw_print_array($boxes);
        $quote_box = array(
            'Name' => $boxType->getReference(),
            'Length' => fcsfw_convertUnits($boxType->getOuterLength(),"mm",$dimension_unit),
            'Length' => fcsfw_convertUnits($boxType->getOuterLength(),"mm",$dimension_unit),
            'Width'  => fcsfw_convertUnits($boxType->getOuterWidth(),"mm",$dimension_unit),
            'Height' => fcsfw_convertUnits($boxType->getOuterDepth(),"mm",$dimension_unit),
            'Weight' => $converted_weight_box
        );

        // Do to Imperial to Metric then back conversion, we want to get the original box array here 
        foreach ($boxes as $box) {
        if ($box['Name'] == $boxType->getReference()) {
            $quote_box = $box;
            break;
        }
        }
        //fcsfw_print_array($box);
        
        // Stop processing at 1 Box , extend this function for multi box support. 
        //break;
    }

*/

// Add an array to store the packed boxes and their respective items
$packedBoxesDetails = [];

foreach ($packedBoxes as $packedBox) {
    $boxType = $packedBox->getBox(); // Box object

    $quote_box = array(
        'Name' => $boxType->getReference(),
        'Length' => fcsfw_convertUnits($boxType->getOuterLength(),"mm",$dimension_unit),
        'Width'  => fcsfw_convertUnits($boxType->getOuterWidth(),"mm",$dimension_unit),
        'Height' => fcsfw_convertUnits($boxType->getOuterDepth(),"mm",$dimension_unit),
        'Weight' => $converted_weight_box
        //$converted_weight_box = fcsfw_convertUnits($box['Weight'],$weight_unit,"g")
    );

    $items = [];
    $packedItems = $packedBox->getItems();
    foreach ($packedItems as $packedItem) {
        $items[] = $packedItem->getItem()->getDescription();  // Just item description for simplicity. Modify according to your needs.
    }

    // Add the packed box and its items to the array
    $packedBoxesDetails[] = ['Box' => $quote_box, 'Items' => $items];
}

        // Do to Imperial to Metric then back conversion, we want to get the original box array here 
        foreach ($boxes as $box) {
                //if ($box['Name'] == $boxType->getReference() ) {
                if ($boxType && $box['Name'] == $boxType->getReference() ) {
            // var_dump($box['Weight']);
                    $quote_box = $box;
                    // Set full package weight
                    //$quote_box['Weight'] = $packedBoxesDetails[0]['Box']['Weight'];
                    break;
                }
        }

// Multibox Support (Not supported currentley v2+)
//$quote_box = $packedBoxesDetails;

// Output the packed boxes and their items at the end
//fcsfw_print_array($packedBoxesDetails[0]['Box']['Weight']);